REM Free disk space in PDS 7.1
TYPE Regtype
  AX AS INTEGER
  BX AS INTEGER
  CX AS INTEGER
  DX AS INTEGER
  BP AS INTEGER
  SI AS INTEGER
  DI AS INTEGER
  Flags AS INTEGER
END TYPE
TYPE RegtypeF
  AH AS STRING * 1
  AL AS STRING * 1
  BH AS STRING * 1
  BL AS STRING * 1
  CH AS STRING * 1
  CL AS STRING * 1
  DH AS STRING * 1
  DL AS STRING * 1
  BP AS INTEGER
  SI AS INTEGER
  DI AS INTEGER
  Flags AS INTEGER
END TYPE
DECLARE SUB Interrupt (N AS INTEGER, I AS Regtype, O AS RegtypeF)
DIM Inregs AS Regtype, OutregsF AS RegtypeF
LINE INPUT "Disk drive letter? ", D$
Inregs.AX = &H3600
Inregs.DX = ASC(UCASE$(D$)) - 64
CALL Interrupt(&H21, Inregs, OutregsF)
IF CVI(OutregsF.AH + OutregsF.AL) = &HFFFF THEN
   PRINT "Invalid drive.": END
END IF
Sectors# = ASC(OutregsF.AL)
Sectors# = Sectors# * 256
Sectors# = Sectors# + ASC(OutregsF.AH)
Clusters# = ASC(OutregsF.BL)
Clusters# = Clusters# * 256
Clusters# = Clusters# + ASC(OutregsF.BH)
Bytes# = ASC(OutregsF.CL)
Bytes# = Bytes# * 256
Bytes# = Bytes# + ASC(OutregsF.CH)
DiskSpace# = Sectors# * Clusters# * Bytes#
PRINT "Free disk space"; DiskSpace#; "bytes."
END

